package dev.shadowsoffire.apotheosis.mixin;

import net.minecraft.network.chat.Style;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import net.minecraft.network.chat.TextColor;
import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.world.item.enchantment.Enchantment;
import org.spongepowered.asm.mixin.Mixin;

@Mixin(value = { Enchantment.class }, priority = 1500)
public class EnchantmentMixin
{
    @Inject(method = { "getFullname" }, at = { @At("RETURN") }, cancellable = true)
    public void apoth_modifyEnchColorForAboveMaxLevel(final int level, final CallbackInfoReturnable<Component> cir) {
        final Enchantment ench = (Enchantment)this;
        if (!ench.m_6589_() && level > ench.m_6586_()) {
            final Object returnValue = cir.getReturnValue();
            if (returnValue instanceof final MutableComponent mc) {
                cir.setReturnValue((Object)mc.m_130938_(s -> s.m_131148_((TextColor)Ench.Colors.LIGHT_BLUE_FLASH)));
            }
        }
    }
}
